unit uFrmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, uFrmBase, Vcl.StdCtrls, uWorkThread;

type
  TFrmMain = class(TFrmBase)
    btnCount: TButton;
    edtNum: TEdit;
    procedure btnCountClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FWorkThread: TWorkThread;

    procedure OnWorkStatus(Sender: TWorkThread; AStatus: TWorkStatus);
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}
{ TFrmMain }

procedure TFrmMain.btnCountClick(Sender: TObject);
var
  nNum: integer;
begin
  inherited;
  nNum := StrToIntDef(edtNum.Text, 0);

  btnCount.Enabled := false;

  FWorkThread.Num := nNum;
  FWorkThread.StartWork;

end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  inherited;
  FWorkThread := TWorkThread.Create;
  FWorkThread.OnDispMsg := self.OnThreadDispMsg;
  FWorkThread.OnWorkStatus := self.OnWorkStatus;
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  inherited;
  FWorkThread.Free;
end;

procedure TFrmMain.OnWorkStatus(Sender: TWorkThread; AStatus: TWorkStatus);
var
  nSum: integer;
begin

  // Ĵ룬Ҳ̴߳롣
  if AStatus = wsOver then
  begin
    nSum := Sender.Sum;
    OnThreadDispMsg('Sum:' + IntToStr(nSum));

    TThread.Synchronize(nil,
      procedure
      begin
        btnCount.Enabled := true;
      end);

  end;

end;

end.
