unit uWorkThread;

interface

uses
  System.Classes, System.SyncObjs;

type

  TOnDispMsg = procedure(AMsg: String) of object;

  TWorkThread = class; // ǰ

  TWorkStatus = (wsStart, wsOver);

  TOnWorkStatus = procedure(Sender: TWorkThread; AStatus: TWorkStatus) of object;

  TWorkThread = class(TThread)
  private
    { Private declarations }
    FEvent: TEvent;
    FOnDispMsg: TOnDispMsg;
    FOnWorkStatus: TOnWorkStatus;
    FNum: Integer;
    FSum: Integer;

    procedure SetOnDispMsg(val: TOnDispMsg);
    procedure SetOnWorkStatus(val: TOnWorkStatus);
    procedure SetNum(val: Integer);

    procedure DoOnDispMsg(AMsg: string);
    procedure DoOnWorkStatus(AStatus: TWorkStatus);

  protected
    procedure Execute; override;
  public

    constructor Create; reintroduce;
    destructor Destroy; override;

    procedure StartWork;

    property OnDispMsg: TOnDispMsg read FOnDispMsg write SetOnDispMsg;
    property OnWorkStatus: TOnWorkStatus read FOnWorkStatus write SetOnWorkStatus;
    property Num: Integer read FNum write SetNum;
    property Sum: Integer read FSum;
  end;

implementation

{ TWorkThread }
uses SysUtils;

constructor TWorkThread.Create;
begin
  inherited Create(false);
  FEvent := TEvent.Create(nil, true, false, 'Demo001'); // GUID
  FreeOnTerminate := false;
end;

destructor TWorkThread.Destroy;
begin
  Terminate;
  FEvent.SetEvent; // ź
  waitfor;
  FEvent.Free;
  inherited;
end;

procedure TWorkThread.DoOnDispMsg(AMsg: string);
begin
  if Assigned(FOnDispMsg) then
    FOnDispMsg(AMsg);
end;

procedure TWorkThread.DoOnWorkStatus(AStatus: TWorkStatus);
begin
  if Assigned(FOnWorkStatus) then
    FOnWorkStatus(self, AStatus);
end;

procedure TWorkThread.Execute;
var
  i: Integer;
begin

  repeat

    FEvent.waitfor; // ûźž
    FEvent.ResetEvent; // ͷź
    if Terminated then
      break;

    DoOnDispMsg('߳...');

    DoOnDispMsg('Num:' + IntToStr(FNum));
    FSum := 0;

    for i := 1 to FNum do
    begin
      FSum := FSum + i;
      sleep(1);
    end;

    DoOnWorkStatus(wsOver);

  until false;

end;

procedure TWorkThread.SetOnDispMsg(val: TOnDispMsg);
begin
  FOnDispMsg := val;
end;

procedure TWorkThread.SetOnWorkStatus(val: TOnWorkStatus);
begin
  FOnWorkStatus := val;
end;

procedure TWorkThread.StartWork;
begin
  FEvent.SetEvent;
end;

procedure TWorkThread.SetNum(val: Integer);
begin
  FNum := val;
end;

end.
